"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TStyles = void 0;

var _cssProcessor = require("@native-html/css-processor");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * A cheap merge method using prototype inheritance.
 *
 * @param child
 * @param parent
 */
function inheritProperties(child, parent) {
  if (!parent) {
    return child;
  }

  return { ...parent,
    ...child
  };
}

class TStyles {
  constructor(ownProcessedProps, parentStyles) {
    _defineProperty(this, "nativeTextFlow", void 0);

    _defineProperty(this, "nativeBlockFlow", void 0);

    _defineProperty(this, "nativeTextRet", void 0);

    _defineProperty(this, "nativeBlockRet", void 0);

    _defineProperty(this, "webTextFlow", void 0);

    this.nativeTextFlow = inheritProperties(ownProcessedProps.native.text.flow, parentStyles === null || parentStyles === void 0 ? void 0 : parentStyles.nativeTextFlow);
    this.nativeBlockFlow = inheritProperties(ownProcessedProps.native.block.flow, parentStyles === null || parentStyles === void 0 ? void 0 : parentStyles.nativeBlockFlow);
    this.webTextFlow = inheritProperties(ownProcessedProps.web.text.flow, parentStyles === null || parentStyles === void 0 ? void 0 : parentStyles.webTextFlow);
    this.nativeTextRet = ownProcessedProps.native.text.retain;
    this.nativeBlockRet = ownProcessedProps.native.block.retain;
  }

  static empty() {
    return new TStyles(new _cssProcessor.CSSProcessedProps());
  }

}

exports.TStyles = TStyles;
//# sourceMappingURL=TStyles.js.map